;==============================================================================
    include \masm32\include\masm32rt.inc
    include \masm32\include\advapi32.inc
    includelib \masm32\lib\advapi32.lib

    Z_BEST_COMPRESSION equ 9

    compress2 PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;==============================================================================
    .data
        hProv     dd 0
        destLen   dd 0
        randBuff  db 100000 dup(0)
        compBuff  db 120000 dup(0)
    .code
;==============================================================================
start:
;==============================================================================

    PROV_RSA_FULL EQU 1

    ;----------------------------------------------------------------
    ; This value for the dwFlags parameter of CryptAcquireContext is
    ; necessary for Windows 2000 (and later AFAIK). For Windows 98
    ; the parameter can be zero.
    ;----------------------------------------------------------------

    CRYPT_VERIFYCONTEXT EQU 0F0000000h

    ;------------------------------------------------
    ; Fill randBuff with random bytes generated by
    ; the cryptographic service provider(CSP).
    ;------------------------------------------------

    invoke CryptAcquireContext, ADDR hProv,
                                NULL,
                                NULL,
                                PROV_RSA_FULL,
                                CRYPT_VERIFYCONTEXT
    .IF eax == 0
        print "CryptAcquireContext failed",13,10
    .ENDIF

    invoke CryptGenRandom, hProv, 100000, ADDR randBuff
    .IF eax == 0
        print "CryptGenRandom failed",13,10
    .ENDIF

    invoke CryptReleaseContext, hProv, 0

    ;----------------------------------------------------
    ; Write the buffer out to a file for external tests.
    ;----------------------------------------------------

    mov ebx, fcreate("goodrand.bin")
    mov eax, fwrite(ebx, ADDR randBuff, 100000)
    push eax
    print "bytes written: "
    pop eax
    print str$(eax),13,10
    fclose ebx

    ;----------------------------------------------
    ; Map zlib1.dll into our address space and get
    ; the address of the compress2 function.
    ;----------------------------------------------

    invoke LoadLibrary, chr$("zlib1.dll")
    mov edi, eax
    print "hinstLib: "
    print hex$(edi),"h",13,10
    invoke GetProcAddress, edi, chr$("compress2")
    mov edi, eax
    print "compress2 address: "
    print hex$(edi),"h",13,10

    ;-------------------------------------------------
    ; Attempt to compress the buffer, specifying best
    ; compression, and display the compressed size.
    ;------------------------------------------------

    mov destLen, 120000
    push Z_BEST_COMPRESSION
    push 100000
    push OFFSET randBuff
    push OFFSET destLen
    push OFFSET compBuff
    call edi
    add esp, 20
    print "compressed length: "
    print str$(destLen),13,10

    ;-----------------------------------
    ; Bias the sequence in the buffer by
    ; setting every eight byte to zero.
    ;-----------------------------------

    xor ebx, ebx
    .WHILE ebx < 100000
        mov randBuff[ebx], 0
        add ebx, 8
    .ENDW

    ;----------------------------------------------------
    ; Write the buffer out to a file for external tests.
    ;----------------------------------------------------

    mov ebx, fcreate("badrand.bin")
    mov eax, fwrite(ebx, ADDR randBuff, 100000)
    push eax
    print "bytes written: "
    pop eax
    print str$(eax),13,10
    fclose ebx

    ;-------------------------------------------------
    ; Attempt to compress the buffer, specifying best
    ; compression, and display the compressed size.
    ;------------------------------------------------

    mov destLen, 120000
    push Z_BEST_COMPRESSION
    push 100000
    push OFFSET randBuff
    push OFFSET destLen
    push OFFSET compBuff
    call edi
    add esp, 20
    print "compressed length: "
    print str$(destLen),13,10,13,10

    inkey "Press any key to exit..."
    exit

;==============================================================================
end start
